;******************************************************************************
;  *   	@MCU   	   	   	   	 : MC30P6250
;  *   	@Create Date         : 2020.01.09
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@֧QQȺ   	  : 814641858      
;  *    @΢ٷ̳   	  : http://bbs.sinomcu.com/	 
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------    	
;  *           	   	   	 T1 5s־һ   P10жϻ
;******************************************************************************
#include "MC30P6250.INC"

cblock 0x0010
abuf
statusbuf
timer1_count1
timer1_count1_H
flag1
ENDC


#define	FLAG_TIMER1_5000ms 	flag1,0

   	ORG     0x0000
   	goto   	MAIN
    ORG     0x8
   	goto   	INT_ISR	   	;ж

 
INT_ISR:

   	movra   abuf
   	swapar  STATUS
   	movra   statusbuf

   	JBSET  	T0IF
   	GOTO   	T0_END
   	JBSET  	T0IE
   	GOTO   	T0_END
   	BCLR   	T0IF
T0_END:

   	JBSET  	T1IF
   	GOTO   	T1_END
   	JBSET  	T1IE
   	GOTO   	T1_END
   	BCLR   	T1IF
   	INCR   	timer1_count1
   	JBCLR  	STATUS,2
   	INCR   	(timer1_count1 + 1)

   	MOVAI  	0x13
   	RSUBAR 	(timer1_count1 + 1)
   	JBSET  	STATUS,2
   	GOTO   	T1_OUT
   	MOVAI  	0x88
   	RSUBAR 	timer1_count1
T1_OUT:
   	JBSET  	STATUS,0
   	GOTO   	T1_END
   	CLRR   	timer1_count1
   	CLRR   	(timer1_count1 + 1)
   	BSET   	FLAG_TIMER1_5000ms
T1_END:

   	swapar  statusbuf
   	movra   STATUS
   	swapr   abuf
   	swapar  abuf
END_OF_INTERRUPT
   	RETIE  	


MAIN:

   	CALL   	SYS_INIT
SLEEP_LOOP:

   	JBSET  	FLAG_TIMER1_5000ms
   	GOTO   	SLEEP_LOOP
   	BCLR   	FLAG_TIMER1_5000ms
   	BCLR   	GIE
   	BCLR   	KBIF
   	BSET   	KBIE
   	NOP
    NOP
    STOP
    NOP
    NOP
   	BCLR   	KBIE
   	BCLR   	KBIF
   	BSET   	GIE
   	GOTO   	SLEEP_LOOP
   	RETURN 	
; exit point of MAIN


SYS_INIT:

   	BCLR   	GIE
   	CALL   	CLR_RAM
   	CALL   	IO_INIT
   	CALL   	TIMER1_INT_INIT
   	CALL   	KBIE_INIT
   	BSET   	GIE
   	RETURN 	
; exit point of SYS_INIT


KBIE_INIT:

   	MOVAI  	0x01
   	MOVRA  	DDR1                    ;in
   	MOVAI  	0xfe
   	MOVRA  	PUCON                   ;
   	MOVAI  	0x01
   	MOVRA  	P1KBCR                  ;P10ж
   	RETURN 	
; exit point of KBIE_INIT


TIMER1_INT_INIT:

   	MOVAI  	0x86
   	MOVRA  	T1CR                        ;64Ƶ
   	MOVAI  	124
   	MOVRA  	T1LOAD                      ;1ms
   	MOVAI  	124
   	MOVRA  	T1CNT
   	BSET   	T1IE
   	RETURN 	
; exit point of TIMER1_INT_INIT


IO_INIT:
   	CLRR   	P1                          ;1:input 0:output   
   	CLRR  	DDR1                        ;1:input 0:output
   	MOVAI  	0xff
   	MOVRA  	PUCON                       ;0:Effective 1:invalid
   	MOVRA  	PDCON                       ;0:Effective 1:invalid    
   	CLRR   	ODCON                       ;0:  1:©
   	RETURN 	
; exit point of IO_INIT


CLR_RAM:
   	movai 0x40
   	movra FSR
   	movai 48
   	movra 0x07
   	decr FSR
   	clrr INDF
   	djzr 0x07
   	goto $ -3;
   	clrr 0x07
   	
   	RETURN 	
; exit point of CLR_RAM

   	end


